#line 1 "ext/puma_http11/http11_parser.rl"
/**
* Copyright (c) 2005 Zed A. Shaw
* You can redistribute it and/or modify it under the same terms as Ruby.
* License 3-clause BSD
*/
#include "http11_parser.h"
#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

/*
* capitalizes all lower-case ASCII characters,
* converts dashes to underscores, and underscores to commas.
*/
static void snake_upcase_char(char *c)
{
	if (*c >= 'a' && *c <= 'z')
		*c &= ~0x20;
	else if (*c == '_')
		*c = ',';
	else if (*c == '-')
		*c = '_';
}

#define LEN(AT, FPC) (FPC - buffer - parser->AT)
#define MARK(M,FPC) (parser->M = (FPC) - buffer)
#define PTR_TO(F) (buffer + parser->F)

/** Machine **/


#line 81 "ext/puma_http11/http11_parser.rl"


/** Data **/

#line 38 "ext/puma_http11/http11_parser.c"
static const int puma_parser_start = 1;
static const int puma_parser_first_final = 46;
static const int puma_parser_error = 0;

static const int puma_parser_en_main = 1;


#line 84 "ext/puma_http11/http11_parser.rl"


int puma_parser_init(puma_parser *parser)  {
	int cs = 0;

#line 49 "ext/puma_http11/http11_parser.c"
	{
		cs = (int)puma_parser_start;
	}
	
#line 88 "ext/puma_http11/http11_parser.rl"

	parser->cs = cs;
	parser->body_start = 0;
	parser->content_len = 0;
	parser->mark = 0;
	parser->nread = 0;
	parser->field_len = 0;
	parser->field_start = 0;
	parser->request = Qnil;
	parser->body = Qnil;
	
	return 1;
}


/** exec **/
size_t puma_parser_execute(puma_parser *parser, const char *buffer, size_t len, size_t off)  {
	const char *p, *pe;
	int cs = parser->cs;
	
	assert(off <= len && "offset past end of buffer");
	
	p = buffer+off;
	pe = buffer+len;
	
	/* assert(*pe == '\0' && "pointer does not end on NUL"); */
	assert((size_t) (pe - p) == len - off && "pointers aren't same distance");
	

#line 81 "ext/puma_http11/http11_parser.c"
{
		switch ( cs ) {
			case 1:
			goto st_case_1;
			case 0:
			goto st_case_0;
			case 2:
			goto st_case_2;
			case 3:
			goto st_case_3;
			case 4:
			goto st_case_4;
			case 5:
			goto st_case_5;
			case 6:
			goto st_case_6;
			case 7:
			goto st_case_7;
			case 8:
			goto st_case_8;
			case 9:
			goto st_case_9;
			case 10:
			goto st_case_10;
			case 11:
			goto st_case_11;
			case 12:
			goto st_case_12;
			case 13:
			goto st_case_13;
			case 14:
			goto st_case_14;
			case 15:
			goto st_case_15;
			case 16:
			goto st_case_16;
			case 46:
			goto st_case_46;
			case 17:
			goto st_case_17;
			case 18:
			goto st_case_18;
			case 19:
			goto st_case_19;
			case 20:
			goto st_case_20;
			case 21:
			goto st_case_21;
			case 22:
			goto st_case_22;
			case 23:
			goto st_case_23;
			case 24:
			goto st_case_24;
			case 25:
			goto st_case_25;
			case 26:
			goto st_case_26;
			case 27:
			goto st_case_27;
			case 28:
			goto st_case_28;
			case 29:
			goto st_case_29;
			case 30:
			goto st_case_30;
			case 31:
			goto st_case_31;
			case 32:
			goto st_case_32;
			case 33:
			goto st_case_33;
			case 34:
			goto st_case_34;
			case 35:
			goto st_case_35;
			case 36:
			goto st_case_36;
			case 37:
			goto st_case_37;
			case 38:
			goto st_case_38;
			case 39:
			goto st_case_39;
			case 40:
			goto st_case_40;
			case 41:
			goto st_case_41;
			case 42:
			goto st_case_42;
			case 43:
			goto st_case_43;
			case 44:
			goto st_case_44;
			case 45:
			goto st_case_45;
		}
		p+= 1;
		st_case_1:
		if ( p == pe )
			goto _out1;
		switch( ( (*( p))) ) {
			case 36: {
				goto _ctr2;
			}
			case 95: {
				goto _ctr2;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _ctr2;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _ctr2;
			}
		} else {
			goto _ctr2;
		}
		goto _st0;
		_st0:
		st_case_0:
		goto _out0;
		_ctr2:
			{
#line 37 "ext/puma_http11/http11_parser.rl"
			MARK(mark, p); }
		
#line 210 "ext/puma_http11/http11_parser.c"

		goto _st2;
		_st2:
		p+= 1;
		st_case_2:
		if ( p == pe )
			goto _out2;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st27;
			}
			case 95: {
				goto _st27;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st27;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st27;
			}
		} else {
			goto _st27;
		}
		goto _st0;
		_ctr4:
			{
#line 50 "ext/puma_http11/http11_parser.rl"
			
			parser->request_method(parser, PTR_TO(mark), LEN(mark, p));
		}
		
#line 247 "ext/puma_http11/http11_parser.c"

		goto _st3;
		_st3:
		p+= 1;
		st_case_3:
		if ( p == pe )
			goto _out3;
		switch( ( (*( p))) ) {
			case 42: {
				goto _ctr7;
			}
			case 43: {
				goto _ctr8;
			}
			case 47: {
				goto _ctr9;
			}
			case 58: {
				goto _ctr10;
			}
		}
		if ( ( (*( p))) < 65 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 57 ) {
				goto _ctr8;
			}
		} else if ( ( (*( p))) > 90 ) {
			if ( 97 <= ( (*( p))) && ( (*( p))) <= 122 ) {
				goto _ctr8;
			}
		} else {
			goto _ctr8;
		}
		goto _st0;
		_ctr7:
			{
#line 37 "ext/puma_http11/http11_parser.rl"
			MARK(mark, p); }
		
#line 285 "ext/puma_http11/http11_parser.c"

		goto _st4;
		_st4:
		p+= 1;
		st_case_4:
		if ( p == pe )
			goto _out4;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr12;
			}
			case 35: {
				goto _ctr13;
			}
		}
		goto _st0;
		_ctr12:
			{
#line 53 "ext/puma_http11/http11_parser.rl"
			
			parser->request_uri(parser, PTR_TO(mark), LEN(mark, p));
		}
		
#line 308 "ext/puma_http11/http11_parser.c"

		goto _st5;
		_ctr40:
			{
#line 37 "ext/puma_http11/http11_parser.rl"
			MARK(mark, p); }
		
#line 315 "ext/puma_http11/http11_parser.c"

			{
#line 56 "ext/puma_http11/http11_parser.rl"
			
			parser->fragment(parser, PTR_TO(mark), LEN(mark, p));
		}
		
#line 322 "ext/puma_http11/http11_parser.c"

		goto _st5;
		_ctr43:
			{
#line 56 "ext/puma_http11/http11_parser.rl"
			
			parser->fragment(parser, PTR_TO(mark), LEN(mark, p));
		}
		
#line 331 "ext/puma_http11/http11_parser.c"

		goto _st5;
		_ctr47:
			{
#line 69 "ext/puma_http11/http11_parser.rl"
			
			parser->request_path(parser, PTR_TO(mark), LEN(mark,p));
		}
		
#line 340 "ext/puma_http11/http11_parser.c"

			{
#line 53 "ext/puma_http11/http11_parser.rl"
			
			parser->request_uri(parser, PTR_TO(mark), LEN(mark, p));
		}
		
#line 347 "ext/puma_http11/http11_parser.c"

		goto _st5;
		_ctr51:
			{
#line 60 "ext/puma_http11/http11_parser.rl"
			MARK(query_start, p); }
		
#line 354 "ext/puma_http11/http11_parser.c"

			{
#line 61 "ext/puma_http11/http11_parser.rl"
			
			parser->query_string(parser, PTR_TO(query_start), LEN(query_start, p));
		}
		
#line 361 "ext/puma_http11/http11_parser.c"

			{
#line 53 "ext/puma_http11/http11_parser.rl"
			
			parser->request_uri(parser, PTR_TO(mark), LEN(mark, p));
		}
		
#line 368 "ext/puma_http11/http11_parser.c"

		goto _st5;
		_ctr55:
			{
#line 61 "ext/puma_http11/http11_parser.rl"
			
			parser->query_string(parser, PTR_TO(query_start), LEN(query_start, p));
		}
		
#line 377 "ext/puma_http11/http11_parser.c"

			{
#line 53 "ext/puma_http11/http11_parser.rl"
			
			parser->request_uri(parser, PTR_TO(mark), LEN(mark, p));
		}
		
#line 384 "ext/puma_http11/http11_parser.c"

		goto _st5;
		_st5:
		p+= 1;
		st_case_5:
		if ( p == pe )
			goto _out5;
		if ( ( (*( p))) == 72 ) {
			goto _ctr15;
		}
		goto _st0;
		_ctr15:
			{
#line 37 "ext/puma_http11/http11_parser.rl"
			MARK(mark, p); }
		
#line 400 "ext/puma_http11/http11_parser.c"

		goto _st6;
		_st6:
		p+= 1;
		st_case_6:
		if ( p == pe )
			goto _out6;
		if ( ( (*( p))) == 84 ) {
			goto _st7;
		}
		goto _st0;
		_st7:
		p+= 1;
		st_case_7:
		if ( p == pe )
			goto _out7;
		if ( ( (*( p))) == 84 ) {
			goto _st8;
		}
		goto _st0;
		_st8:
		p+= 1;
		st_case_8:
		if ( p == pe )
			goto _out8;
		if ( ( (*( p))) == 80 ) {
			goto _st9;
		}
		goto _st0;
		_st9:
		p+= 1;
		st_case_9:
		if ( p == pe )
			goto _out9;
		if ( ( (*( p))) == 47 ) {
			goto _st10;
		}
		goto _st0;
		_st10:
		p+= 1;
		st_case_10:
		if ( p == pe )
			goto _out10;
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto _st11;
		}
		goto _st0;
		_st11:
		p+= 1;
		st_case_11:
		if ( p == pe )
			goto _out11;
		if ( ( (*( p))) == 46 ) {
			goto _st12;
		}
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto _st11;
		}
		goto _st0;
		_st12:
		p+= 1;
		st_case_12:
		if ( p == pe )
			goto _out12;
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto _st13;
		}
		goto _st0;
		_st13:
		p+= 1;
		st_case_13:
		if ( p == pe )
			goto _out13;
		if ( ( (*( p))) == 13 ) {
			goto _ctr24;
		}
		if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
			goto _st13;
		}
		goto _st0;
		_ctr24:
			{
#line 65 "ext/puma_http11/http11_parser.rl"
			
			parser->server_protocol(parser, PTR_TO(mark), LEN(mark, p));
		}
		
#line 487 "ext/puma_http11/http11_parser.c"

		goto _st14;
		_ctr35:
			{
#line 46 "ext/puma_http11/http11_parser.rl"
			MARK(mark, p); }
		
#line 494 "ext/puma_http11/http11_parser.c"

			{
#line 47 "ext/puma_http11/http11_parser.rl"
			
			parser->http_field(parser, PTR_TO(field_start), parser->field_len, PTR_TO(mark), LEN(mark, p));
		}
		
#line 501 "ext/puma_http11/http11_parser.c"

		goto _st14;
		_ctr38:
			{
#line 47 "ext/puma_http11/http11_parser.rl"
			
			parser->http_field(parser, PTR_TO(field_start), parser->field_len, PTR_TO(mark), LEN(mark, p));
		}
		
#line 510 "ext/puma_http11/http11_parser.c"

		goto _st14;
		_st14:
		p+= 1;
		st_case_14:
		if ( p == pe )
			goto _out14;
		if ( ( (*( p))) == 10 ) {
			goto _st15;
		}
		goto _st0;
		_st15:
		p+= 1;
		st_case_15:
		if ( p == pe )
			goto _out15;
		switch( ( (*( p))) ) {
			case 13: {
				goto _st16;
			}
			case 33: {
				goto _ctr28;
			}
			case 124: {
				goto _ctr28;
			}
			case 126: {
				goto _ctr28;
			}
		}
		if ( ( (*( p))) < 45 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 43 ) {
					goto _ctr28;
				}
			} else if ( ( (*( p))) >= 35 ) {
				goto _ctr28;
			}
		} else if ( ( (*( p))) > 46 ) {
			if ( ( (*( p))) < 65 ) {
				if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
					goto _ctr28;
				}
			} else if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 122 ) {
					goto _ctr28;
				}
			} else {
				goto _ctr28;
			}
		} else {
			goto _ctr28;
		}
		goto _st0;
		_st16:
		p+= 1;
		st_case_16:
		if ( p == pe )
			goto _out16;
		if ( ( (*( p))) == 10 ) {
			goto _ctr29;
		}
		goto _st0;
		_ctr29:
			{
#line 73 "ext/puma_http11/http11_parser.rl"
			
			parser->body_start = p - buffer + 1;
			parser->header_done(parser, p + 1, pe - p - 1);
			{p+= 1; cs = 46; goto _out;}
		}
		
#line 582 "ext/puma_http11/http11_parser.c"

		goto _st46;
		_st46:
		p+= 1;
		st_case_46:
		if ( p == pe )
			goto _out46;
		goto _st0;
		_ctr28:
			{
#line 40 "ext/puma_http11/http11_parser.rl"
			MARK(field_start, p); }
		
#line 595 "ext/puma_http11/http11_parser.c"

			{
#line 41 "ext/puma_http11/http11_parser.rl"
			snake_upcase_char((char *)p); }
		
#line 600 "ext/puma_http11/http11_parser.c"

		goto _st17;
		_ctr31:
			{
#line 41 "ext/puma_http11/http11_parser.rl"
			snake_upcase_char((char *)p); }
		
#line 607 "ext/puma_http11/http11_parser.c"

		goto _st17;
		_st17:
		p+= 1;
		st_case_17:
		if ( p == pe )
			goto _out17;
		switch( ( (*( p))) ) {
			case 33: {
				goto _ctr31;
			}
			case 58: {
				goto _ctr32;
			}
			case 124: {
				goto _ctr31;
			}
			case 126: {
				goto _ctr31;
			}
		}
		if ( ( (*( p))) < 45 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 43 ) {
					goto _ctr31;
				}
			} else if ( ( (*( p))) >= 35 ) {
				goto _ctr31;
			}
		} else if ( ( (*( p))) > 46 ) {
			if ( ( (*( p))) < 65 ) {
				if ( 48 <= ( (*( p))) && ( (*( p))) <= 57 ) {
					goto _ctr31;
				}
			} else if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 122 ) {
					goto _ctr31;
				}
			} else {
				goto _ctr31;
			}
		} else {
			goto _ctr31;
		}
		goto _st0;
		_ctr32:
			{
#line 42 "ext/puma_http11/http11_parser.rl"
			
			parser->field_len = LEN(field_start, p);
		}
		
#line 659 "ext/puma_http11/http11_parser.c"

		goto _st18;
		_ctr36:
			{
#line 46 "ext/puma_http11/http11_parser.rl"
			MARK(mark, p); }
		
#line 666 "ext/puma_http11/http11_parser.c"

		goto _st18;
		_st18:
		p+= 1;
		st_case_18:
		if ( p == pe )
			goto _out18;
		switch( ( (*( p))) ) {
			case 13: {
				goto _ctr35;
			}
			case 32: {
				goto _ctr36;
			}
			case 127: {
				goto _st0;
			}
		}
		if ( ( (*( p))) > 8 ) {
			if ( 10 <= ( (*( p))) && ( (*( p))) <= 31 ) {
				goto _st0;
			}
		} else {
			goto _st0;
		}
		goto _ctr34;
		_ctr34:
			{
#line 46 "ext/puma_http11/http11_parser.rl"
			MARK(mark, p); }
		
#line 697 "ext/puma_http11/http11_parser.c"

		goto _st19;
		_st19:
		p+= 1;
		st_case_19:
		if ( p == pe )
			goto _out19;
		switch( ( (*( p))) ) {
			case 13: {
				goto _ctr38;
			}
			case 127: {
				goto _st0;
			}
		}
		if ( ( (*( p))) > 8 ) {
			if ( 10 <= ( (*( p))) && ( (*( p))) <= 31 ) {
				goto _st0;
			}
		} else {
			goto _st0;
		}
		goto _st19;
		_ctr13:
			{
#line 53 "ext/puma_http11/http11_parser.rl"
			
			parser->request_uri(parser, PTR_TO(mark), LEN(mark, p));
		}
		
#line 727 "ext/puma_http11/http11_parser.c"

		goto _st20;
		_ctr48:
			{
#line 69 "ext/puma_http11/http11_parser.rl"
			
			parser->request_path(parser, PTR_TO(mark), LEN(mark,p));
		}
		
#line 736 "ext/puma_http11/http11_parser.c"

			{
#line 53 "ext/puma_http11/http11_parser.rl"
			
			parser->request_uri(parser, PTR_TO(mark), LEN(mark, p));
		}
		
#line 743 "ext/puma_http11/http11_parser.c"

		goto _st20;
		_ctr53:
			{
#line 60 "ext/puma_http11/http11_parser.rl"
			MARK(query_start, p); }
		
#line 750 "ext/puma_http11/http11_parser.c"

			{
#line 61 "ext/puma_http11/http11_parser.rl"
			
			parser->query_string(parser, PTR_TO(query_start), LEN(query_start, p));
		}
		
#line 757 "ext/puma_http11/http11_parser.c"

			{
#line 53 "ext/puma_http11/http11_parser.rl"
			
			parser->request_uri(parser, PTR_TO(mark), LEN(mark, p));
		}
		
#line 764 "ext/puma_http11/http11_parser.c"

		goto _st20;
		_ctr56:
			{
#line 61 "ext/puma_http11/http11_parser.rl"
			
			parser->query_string(parser, PTR_TO(query_start), LEN(query_start, p));
		}
		
#line 773 "ext/puma_http11/http11_parser.c"

			{
#line 53 "ext/puma_http11/http11_parser.rl"
			
			parser->request_uri(parser, PTR_TO(mark), LEN(mark, p));
		}
		
#line 780 "ext/puma_http11/http11_parser.c"

		goto _st20;
		_st20:
		p+= 1;
		st_case_20:
		if ( p == pe )
			goto _out20;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr40;
			}
			case 60: {
				goto _st0;
			}
			case 62: {
				goto _st0;
			}
			case 127: {
				goto _st0;
			}
		}
		if ( ( (*( p))) > 31 ) {
			if ( 34 <= ( (*( p))) && ( (*( p))) <= 35 ) {
				goto _st0;
			}
		} else {
			goto _st0;
		}
		goto _ctr41;
		_ctr41:
			{
#line 37 "ext/puma_http11/http11_parser.rl"
			MARK(mark, p); }
		
#line 814 "ext/puma_http11/http11_parser.c"

		goto _st21;
		_st21:
		p+= 1;
		st_case_21:
		if ( p == pe )
			goto _out21;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr43;
			}
			case 60: {
				goto _st0;
			}
			case 62: {
				goto _st0;
			}
			case 127: {
				goto _st0;
			}
		}
		if ( ( (*( p))) > 31 ) {
			if ( 34 <= ( (*( p))) && ( (*( p))) <= 35 ) {
				goto _st0;
			}
		} else {
			goto _st0;
		}
		goto _st21;
		_ctr8:
			{
#line 37 "ext/puma_http11/http11_parser.rl"
			MARK(mark, p); }
		
#line 848 "ext/puma_http11/http11_parser.c"

		goto _st22;
		_st22:
		p+= 1;
		st_case_22:
		if ( p == pe )
			goto _out22;
		switch( ( (*( p))) ) {
			case 43: {
				goto _st22;
			}
			case 58: {
				goto _st23;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st22;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 97 <= ( (*( p))) && ( (*( p))) <= 122 ) {
					goto _st22;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st22;
			}
		} else {
			goto _st22;
		}
		goto _st0;
		_ctr10:
			{
#line 37 "ext/puma_http11/http11_parser.rl"
			MARK(mark, p); }
		
#line 884 "ext/puma_http11/http11_parser.c"

		goto _st23;
		_st23:
		p+= 1;
		st_case_23:
		if ( p == pe )
			goto _out23;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr12;
			}
			case 34: {
				goto _st0;
			}
			case 35: {
				goto _ctr13;
			}
			case 60: {
				goto _st0;
			}
			case 62: {
				goto _st0;
			}
			case 127: {
				goto _st0;
			}
		}
		if ( ( (*( p))) <= 31 ) {
			goto _st0;
		}
		goto _st23;
		_ctr9:
			{
#line 37 "ext/puma_http11/http11_parser.rl"
			MARK(mark, p); }
		
#line 920 "ext/puma_http11/http11_parser.c"

		goto _st24;
		_st24:
		p+= 1;
		st_case_24:
		if ( p == pe )
			goto _out24;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr47;
			}
			case 34: {
				goto _st0;
			}
			case 35: {
				goto _ctr48;
			}
			case 60: {
				goto _st0;
			}
			case 62: {
				goto _st0;
			}
			case 63: {
				goto _ctr49;
			}
			case 127: {
				goto _st0;
			}
		}
		if ( ( (*( p))) <= 31 ) {
			goto _st0;
		}
		goto _st24;
		_ctr49:
			{
#line 69 "ext/puma_http11/http11_parser.rl"
			
			parser->request_path(parser, PTR_TO(mark), LEN(mark,p));
		}
		
#line 961 "ext/puma_http11/http11_parser.c"

		goto _st25;
		_st25:
		p+= 1;
		st_case_25:
		if ( p == pe )
			goto _out25;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr51;
			}
			case 34: {
				goto _st0;
			}
			case 35: {
				goto _ctr53;
			}
			case 60: {
				goto _st0;
			}
			case 62: {
				goto _st0;
			}
			case 127: {
				goto _st0;
			}
		}
		if ( ( (*( p))) <= 31 ) {
			goto _st0;
		}
		goto _ctr52;
		_ctr52:
			{
#line 60 "ext/puma_http11/http11_parser.rl"
			MARK(query_start, p); }
		
#line 997 "ext/puma_http11/http11_parser.c"

		goto _st26;
		_st26:
		p+= 1;
		st_case_26:
		if ( p == pe )
			goto _out26;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr55;
			}
			case 34: {
				goto _st0;
			}
			case 35: {
				goto _ctr56;
			}
			case 60: {
				goto _st0;
			}
			case 62: {
				goto _st0;
			}
			case 127: {
				goto _st0;
			}
		}
		if ( ( (*( p))) <= 31 ) {
			goto _st0;
		}
		goto _st26;
		_st27:
		p+= 1;
		st_case_27:
		if ( p == pe )
			goto _out27;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st28;
			}
			case 95: {
				goto _st28;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st28;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st28;
			}
		} else {
			goto _st28;
		}
		goto _st0;
		_st28:
		p+= 1;
		st_case_28:
		if ( p == pe )
			goto _out28;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st29;
			}
			case 95: {
				goto _st29;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st29;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st29;
			}
		} else {
			goto _st29;
		}
		goto _st0;
		_st29:
		p+= 1;
		st_case_29:
		if ( p == pe )
			goto _out29;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st30;
			}
			case 95: {
				goto _st30;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st30;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st30;
			}
		} else {
			goto _st30;
		}
		goto _st0;
		_st30:
		p+= 1;
		st_case_30:
		if ( p == pe )
			goto _out30;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st31;
			}
			case 95: {
				goto _st31;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st31;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st31;
			}
		} else {
			goto _st31;
		}
		goto _st0;
		_st31:
		p+= 1;
		st_case_31:
		if ( p == pe )
			goto _out31;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st32;
			}
			case 95: {
				goto _st32;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st32;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st32;
			}
		} else {
			goto _st32;
		}
		goto _st0;
		_st32:
		p+= 1;
		st_case_32:
		if ( p == pe )
			goto _out32;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st33;
			}
			case 95: {
				goto _st33;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st33;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st33;
			}
		} else {
			goto _st33;
		}
		goto _st0;
		_st33:
		p+= 1;
		st_case_33:
		if ( p == pe )
			goto _out33;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st34;
			}
			case 95: {
				goto _st34;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st34;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st34;
			}
		} else {
			goto _st34;
		}
		goto _st0;
		_st34:
		p+= 1;
		st_case_34:
		if ( p == pe )
			goto _out34;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st35;
			}
			case 95: {
				goto _st35;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st35;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st35;
			}
		} else {
			goto _st35;
		}
		goto _st0;
		_st35:
		p+= 1;
		st_case_35:
		if ( p == pe )
			goto _out35;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st36;
			}
			case 95: {
				goto _st36;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st36;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st36;
			}
		} else {
			goto _st36;
		}
		goto _st0;
		_st36:
		p+= 1;
		st_case_36:
		if ( p == pe )
			goto _out36;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st37;
			}
			case 95: {
				goto _st37;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st37;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st37;
			}
		} else {
			goto _st37;
		}
		goto _st0;
		_st37:
		p+= 1;
		st_case_37:
		if ( p == pe )
			goto _out37;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st38;
			}
			case 95: {
				goto _st38;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st38;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st38;
			}
		} else {
			goto _st38;
		}
		goto _st0;
		_st38:
		p+= 1;
		st_case_38:
		if ( p == pe )
			goto _out38;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st39;
			}
			case 95: {
				goto _st39;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st39;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st39;
			}
		} else {
			goto _st39;
		}
		goto _st0;
		_st39:
		p+= 1;
		st_case_39:
		if ( p == pe )
			goto _out39;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st40;
			}
			case 95: {
				goto _st40;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st40;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st40;
			}
		} else {
			goto _st40;
		}
		goto _st0;
		_st40:
		p+= 1;
		st_case_40:
		if ( p == pe )
			goto _out40;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st41;
			}
			case 95: {
				goto _st41;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st41;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st41;
			}
		} else {
			goto _st41;
		}
		goto _st0;
		_st41:
		p+= 1;
		st_case_41:
		if ( p == pe )
			goto _out41;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st42;
			}
			case 95: {
				goto _st42;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st42;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st42;
			}
		} else {
			goto _st42;
		}
		goto _st0;
		_st42:
		p+= 1;
		st_case_42:
		if ( p == pe )
			goto _out42;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st43;
			}
			case 95: {
				goto _st43;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st43;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st43;
			}
		} else {
			goto _st43;
		}
		goto _st0;
		_st43:
		p+= 1;
		st_case_43:
		if ( p == pe )
			goto _out43;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st44;
			}
			case 95: {
				goto _st44;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st44;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st44;
			}
		} else {
			goto _st44;
		}
		goto _st0;
		_st44:
		p+= 1;
		st_case_44:
		if ( p == pe )
			goto _out44;
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr4;
			}
			case 36: {
				goto _st45;
			}
			case 95: {
				goto _st45;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( 45 <= ( (*( p))) && ( (*( p))) <= 46 ) {
				goto _st45;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( 65 <= ( (*( p))) && ( (*( p))) <= 90 ) {
				goto _st45;
			}
		} else {
			goto _st45;
		}
		goto _st0;
		_st45:
		p+= 1;
		st_case_45:
		if ( p == pe )
			goto _out45;
		if ( ( (*( p))) == 32 ) {
			goto _ctr4;
		}
		goto _st0;
		_out1: cs = 1; goto _out; 
		_out0: cs = 0; goto _out; 
		_out2: cs = 2; goto _out; 
		_out3: cs = 3; goto _out; 
		_out4: cs = 4; goto _out; 
		_out5: cs = 5; goto _out; 
		_out6: cs = 6; goto _out; 
		_out7: cs = 7; goto _out; 
		_out8: cs = 8; goto _out; 
		_out9: cs = 9; goto _out; 
		_out10: cs = 10; goto _out; 
		_out11: cs = 11; goto _out; 
		_out12: cs = 12; goto _out; 
		_out13: cs = 13; goto _out; 
		_out14: cs = 14; goto _out; 
		_out15: cs = 15; goto _out; 
		_out16: cs = 16; goto _out; 
		_out46: cs = 46; goto _out; 
		_out17: cs = 17; goto _out; 
		_out18: cs = 18; goto _out; 
		_out19: cs = 19; goto _out; 
		_out20: cs = 20; goto _out; 
		_out21: cs = 21; goto _out; 
		_out22: cs = 22; goto _out; 
		_out23: cs = 23; goto _out; 
		_out24: cs = 24; goto _out; 
		_out25: cs = 25; goto _out; 
		_out26: cs = 26; goto _out; 
		_out27: cs = 27; goto _out; 
		_out28: cs = 28; goto _out; 
		_out29: cs = 29; goto _out; 
		_out30: cs = 30; goto _out; 
		_out31: cs = 31; goto _out; 
		_out32: cs = 32; goto _out; 
		_out33: cs = 33; goto _out; 
		_out34: cs = 34; goto _out; 
		_out35: cs = 35; goto _out; 
		_out36: cs = 36; goto _out; 
		_out37: cs = 37; goto _out; 
		_out38: cs = 38; goto _out; 
		_out39: cs = 39; goto _out; 
		_out40: cs = 40; goto _out; 
		_out41: cs = 41; goto _out; 
		_out42: cs = 42; goto _out; 
		_out43: cs = 43; goto _out; 
		_out44: cs = 44; goto _out; 
		_out45: cs = 45; goto _out; 
		_out: {}
	}
	
#line 116 "ext/puma_http11/http11_parser.rl"

	
	if (!puma_parser_has_error(parser))
		parser->cs = cs;
	parser->nread += p - (buffer + off);
	
	assert(p <= pe && "buffer overflow after parsing execute");
	assert(parser->nread <= len && "nread longer than length");
	assert(parser->body_start <= len && "body starts after buffer end");
	assert(parser->mark < len && "mark is after buffer end");
	assert(parser->field_len <= len && "field has length longer than whole buffer");
	assert(parser->field_start < len && "field starts after buffer end");
	
	return(parser->nread);
}

int puma_parser_finish(puma_parser *parser)
{
	if (puma_parser_has_error(parser) ) {
		return -1;
	} else if (puma_parser_is_finished(parser) ) {
		return 1;
	} else {
		return 0;
	}
}

int puma_parser_has_error(puma_parser *parser) {
	return parser->cs == puma_parser_error;
}

int puma_parser_is_finished(puma_parser *parser) {
	return parser->cs >= puma_parser_first_final;
}
